package net.sf.basedb.examples.extensions;

import net.sf.basedb.clients.web.extensions.JspContext;
import net.sf.basedb.clients.web.extensions.menu.MenuItemAction;
import net.sf.basedb.clients.web.extensions.menu.MenuItemBean;
import net.sf.basedb.util.extensions.ActionFactory;
import net.sf.basedb.util.extensions.InvokationContext;

/**
	First example of an action factory where eveything is hardcoded.
	@author nicklas
*/
public class HelloWorldFactory
	implements ActionFactory<MenuItemAction>
{

	private MenuItemAction[] helloWorld;

	// A public, no-argument constructor is required
	public HelloWorldFactory()
	{
		helloWorld = new MenuItemAction[1];
	}
   
	// Return true enable the extension, false to disable it
	public boolean prepareContext(InvokationContext<? super MenuItemAction> context) 
	{
		return true;
	}

	// An extension may create one or more actions
	public MenuItemAction[] getActions(InvokationContext<? super MenuItemAction> context) 
	{
		// This cast is always safe with the web client
		JspContext jspContext = (JspContext)context.getClientContext();
		if (helloWorld[0] == null)
		{
			MenuItemBean bean = new MenuItemBean();
			bean.setMenuId("hello");
			bean.setTitle("Hello factory world!");
			bean.setIcon(jspContext.getHome(context.getExtension()) + "/images/factory.png");
			bean.setOnClick("alert('Hello factory world!')");
			helloWorld[0] = bean;
		}
		return helloWorld;
	}
}
